﻿package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class Physics extends Sprite {
		private var nbr:Number = 200;// Nombre de boules
		public function Physics() {
			for (var i:Number=0; i<nbr; i++) {
				var ball:Ball = new Ball();
				ball.x = Math.random()*600;
				ball.name = "ball"+i;
				addChild(ball);
			}
			//sécurité pour être sûr que le stage a été ajouter sur le stage
			addEventListener(Event.ADDED_TO_STAGE,added_handler);
		}
		private function added_handler(e:Event):void {
			stage.addEventListener(MouseEvent.CLICK,click_handler);

		}
		private function click_handler(e:MouseEvent):void {
			for (var i:Number=0; i<nbr; i++) {
				var ball:Object =getChildByName("ball"+i);
				ball.x = Math.random()*stage.stageWidth;
				ball.y=0;
				ball.initialisation();
			}
		}
	}
}
import flash.display.Sprite;
import flash.events.MouseEvent;
import flash.events.Event;
import flash.filters.BitmapFilterQuality;
import flash.filters.GlowFilter;
class Ball extends Sprite {
	/*
	Calcul de la vitesse par rapport à l'accélération
	Mise en place d'obstacles sur la chute pour faire "rebond"
	*/
	private var speedy:Number;
	private var speedx:Number;
	private var friction:Number;
	private var ax:Number;
	private var ay:Number;
	private var gravity:Number;

	public function Ball() {
		graphics.beginFill(0x333333,1);
		graphics.drawCircle(0,0,10);
		graphics.endFill();
		
		var glow:GlowFilter = new GlowFilter();
		glow.color = 0x333333;
		glow.alpha = 1;
		glow.blurX = 10;
		glow.blurY = 10;
		glow.quality = BitmapFilterQuality.MEDIUM;

		this.filters = [glow];
		
		initialisation();
		addEventListener(Event.ENTER_FRAME, enter_handler);
	}
	public function initialisation():void {
		speedy = Math.random()*10;
		speedx = Math.random()*10;
		friction = 0.99;
		ax = 0;
		ay = 0;
		gravity = 0.1;
	}
	private function enter_handler(e:Event):void {
		//calcul physique des mouvements 
		speedy += gravity;// à la vitesse vertical on aditionne la gravité
		speedy += ay;// à la vitesse vertical on additionne l'accélération
		speedx += ax;// à la vitesse horizontal on additionne l'accélération (il n'y a pas de gravité à l'horizontal)
		speedy *= friction;// on multiplie la vitesse vertical par la friction (le freinage, l'effet de rebond)
		speedx *= friction;// on multiplie la vitesse horizontale par la friction (le freinage, l'effet de rebond)
		e.currentTarget.y += speedy*0.5;// on se déplace verticalement en rapport à la vitesse verticale calculée
		e.currentTarget.x += speedx*0.8;// on se déplace horizontalement en rapport à la vitesse horizontale calculée
		//si on touche les bords, on rebondit
		if ((e.currentTarget.y + e.currentTarget.height/2)> stage.stageHeight) {
			e.currentTarget.y = stage.stageHeight - e.currentTarget.height/2;
			speedy*=-2;
		}
		if (e.currentTarget.x + e.currentTarget.width/2 > stage.stageWidth) {
			e.currentTarget.x = stage.stageWidth - e.currentTarget.width/2;
			speedx *= -1;
		} else if (e.currentTarget.x - e.currentTarget.width/2 < 4) {
			e.currentTarget.x = e.currentTarget.width/2;
			speedx *= -1;
		}
	}
}